VERSION 5.00
Object = "{4DE9E2A3-150F-11CF-8FBF-444553540000}#4.0#0"; "DLXOCX32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3900
   ClientLeft      =   3045
   ClientTop       =   1725
   ClientWidth     =   4845
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3900
   ScaleWidth      =   4845
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   3600
      TabIndex        =   8
      Top             =   3120
      Width           =   855
   End
   Begin VB.Frame Frame1 
      Caption         =   "Values to Write"
      Height          =   855
      Left            =   2640
      TabIndex        =   5
      Top             =   1920
      Width           =   1815
      Begin VB.OptionButton optLogic1 
         Caption         =   "all lines logic 1"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   480
         Value           =   -1  'True
         Width           =   1335
      End
      Begin VB.OptionButton optLogic0 
         Caption         =   "all lines logic 0"
         Height          =   195
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   1455
      End
   End
   Begin VB.ComboBox devNum 
      Height          =   315
      Left            =   2640
      TabIndex        =   4
      TabStop         =   0   'False
      Text            =   "0"
      Top             =   840
      Width           =   735
   End
   Begin VB.CommandButton cmdConfig 
      Caption         =   "Configure Channels for DO"
      Enabled         =   0   'False
      Height          =   375
      Left            =   360
      TabIndex        =   3
      Top             =   1440
      Width           =   2055
   End
   Begin VB.CommandButton cmdSample 
      Caption         =   "Write to DO Channels"
      Enabled         =   0   'False
      Height          =   375
      Left            =   360
      TabIndex        =   1
      Top             =   2040
      Width           =   2055
   End
   Begin VB.CommandButton cmdInit 
      Caption         =   "Initialize"
      Height          =   375
      Left            =   360
      TabIndex        =   0
      Top             =   840
      Width           =   2055
   End
   Begin DlsrLib.DriverLINXLDD LDD 
      Left            =   2280
      Top             =   120
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin DlsrLib.DriverLINXSR SR 
      Left            =   2880
      Top             =   120
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackColor       =   &H000000FF&
      Caption         =   " KEITHLEY "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000E&
      Height          =   300
      Left            =   360
      TabIndex        =   2
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' this program was written in VB6 in Win98SE
' it was tested using KPCIPIO-850A04 version of DriverLINX
' a KPCI-PIO24 board was used
'
' this example is appropriate for KPCI-PIO24, KPCI-PIO96, KPCI-3160,
' PIO-12, PIO-24, PIO-96J, PIO-SSR Series
'
' it could be appropriate also for the KPCI-3101/2/3/4 but the channel 2
' of those boards has only 7 bits not 8

Private Sub cmdConfig_Click()
' assumes the board has three digital channels that can be configured for output
' if you have KPCI-PIO96 or the KPCI-3160, you have channels 0 through 11
Dim i As Integer
For i = 0 To 2
ConfigureChannelforOutputMode i ' config channel 0, 1 and 2 for output
Next i
' if no error enable button that let's us write value to this channel
If SR.Res_result = DL_NoErr Then
cmdSample.Enabled = True
cmdConfig.Enabled = False
End If
' Check your hardware specifications.  Some boards have digital channels
' with fixed direction (input or output).  DAS-xxxx and many of the special
' purpose digital I/O such as PDISO-8, REL-16, etc.  For these boards, configuration
' of a digital channel for output is not necessary and will raise an error.
'
' Many boards, however, have general purpose digital I/O.  This is true of
' the PIO-12, PIO-24, KPCI-PIOxx, KPCI-3160 and most of the KPCI multifunction
' boards.  Digital ports on these boards initialize as input channels.
' To use them as outputs, they must first be configured for output direction.
'
' If the configuration step is not carried out, an "invalid channel in channel/gain
' list" error message will occur when trying to write to the digital channel.  Assign
' the channel to DL_DO subsystem to avoid this error.
End Sub

Private Sub cmdExit_Click()
' unload the driver for each object
SR.Req_DLL_name = ""
LDD.Req_DLL_name = ""
End
End Sub

Private Sub cmdInit_Click()
' open the driver and initialize the hardware
With SR
.Req_DLL_name = "kpcipio" ' give Driver name to avoid Open DriverLINX dialog
.Req_device = devNum.ListIndex
.Req_mode = DL_OTHER
.Req_op = DL_INITIALIZE
.Req_subsystem = DL_DEVICE
.Refresh
End With

' error check
If SR.Res_result = DL_NoErr Then
cmdConfig.Enabled = True
cmdInit.Enabled = False
' use of the LDD control is not required
LDD.Req_DLL_name = SR.Req_DLL_name
LDD.device = SR.Req_device
LDD.Refresh   'get fresh data for our board
Form1.Caption = LDD.Dev_Model  ' display the model number
Else
SR.Req_op = DL_MESSAGEBOX
SR.Refresh
End If
' the LDD control can inform your application
' about the features of the hardware
Form1.SetFocus  ' set focus back to our dialog
End Sub

Private Sub cmdSample_Click()

SetupDOScan
Dim DOValue(3) As Byte  ' declare a byte array
Dim dummy As Long
' read in value to write to the port
If optLogic0.Value = True Then
DOValue(0) = 0 ' set all bits to logic 0
DOValue(1) = 0 ' set all bits to logic 0
DOValue(2) = 0 ' set all bits to logic 0
Else
DOValue(0) = &HFF ' set all bits to logic 1
DOValue(1) = &HFF ' set all bits to logic 1
DOValue(2) = &HFF ' set all bits to logic 1
End If
' assume an 8bit digital channel....between 0 and 255
' can't use SR.Res_Sta_ioValue since this is not single value XFer
' use VBArrayBufferXfer support method instead to move our byte array
' to the SR control's memory buffer 0
dummy = SR.VBArrayBufferXfer(0, DOValue, DL_VBArrayToBuffer)
SR.Refresh  ' write the values
' error check
SR.Req_op = DL_MESSAGEBOX
SR.Refresh

End Sub

Private Sub Form_Load()
' center the form
   With Form1
        ' Center the form on the screen
        .Left = (Screen.Width - .Width) / 2
        .Top = (Screen.Height - .Height) / 2
   End With
' populate combo box with legal device numbers
Dim i As Integer
For i = 0 To 5
devNum.AddItem Str(i), i
Next i
' set it equal to first entry
devNum.ListIndex = 0
End Sub


Sub SetupDOScan()
With SR
' Request Group
.Req_op = DL_START
.Req_mode = DL_POLLED  ' no pacing clock involved
.Req_subsystem = DL_DO
' Event Group
.Evt_Str_type = DL_COMMAND  ' start when .Refresh is called
.Evt_Stp_type = DL_TCEVENT  ' stop automatically
.Evt_Tim_type = DL_NULLEVENT  ' no timing for Polled mode
' Select Group
.Sel_chan_format = DL_tNATIVE  ' use the card's native format
.Sel_chan_N = 2                ' a start and a stop channel
.Sel_chan_start = 0            ' start on channel 0
.Sel_chan_stop = 2             ' stop on channel 2
.Sel_buf_N = 1                 ' one buffer used
.Sel_buf_samples = 3           ' holds 3 samples...one for each channel
End With
End Sub

Sub ConfigureChannelforOutputMode(ByVal chan As Integer)
With SR
.Req_subsystem = DL_DO  ' assign the channel the DL_DO subsystem
.Req_mode = DL_OTHER
.Req_op = DL_CONFIGURE
.Evt_Tim_type = DL_DIOSETUP
.Evt_Tim_dioChannel = chan
.Evt_Tim_dioMode = DL_DIO_BASIC
.Refresh
End With
End Sub
